#!/bin/bash
set -e

export PROC_COUNT_MAKE_OPTION=`cat /proc/cpuinfo | awk '/^processor/{print "-j"$3+1}' | tail -1`

echo -----------------------------------------------------------------
echo BUILDING pure_asio...
echo -----------------------------------------------------------------

cd pure_asio
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../


echo
echo -----------------------------------------------------------------
echo BUILDING Beast...
echo -----------------------------------------------------------------
cd beast
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING cpprestsdk...
echo -----------------------------------------------------------------
cd cpprestsdk
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING restbed...
echo -----------------------------------------------------------------
cd restbed
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING pistache...
echo -----------------------------------------------------------------
cd pistache
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING poco...
echo -----------------------------------------------------------------
cd poco
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING crow...
echo -----------------------------------------------------------------
cd crow
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../

echo
echo -----------------------------------------------------------------
echo BUILDING restinio...
echo -----------------------------------------------------------------
cd restinio
mkdir -p cmake_build
cd cmake_build
cmake -DCMAKE_INSTALL_PREFIX=../../_bench_run -DCMAKE_BUILD_TYPE=Release ..
make $PROC_COUNT_MAKE_OPTION && make install
cd ../../


