#include <app_args.hpp>

#include "crow.h"

int main(int argc, const char *argv[])
{
    try
    {
        const app_args_t args{ argc, argv };

        if( !args.m_help )
        {
            crow::SimpleApp app;
            app.loglevel(crow::LogLevel::Critical);

            CROW_ROUTE(app, "/")
            ([]() {
                crow::response resp{ "Hello world!" };
                resp.add_header( "Server", "CROW Benchmark");
                resp.add_header( "Content-Type", "text/plain; charset=utf-8" );
                return resp;
            });

            app
                .port(args.m_port)
                .concurrency(args.m_pool_size)
                .run();
        }
    }
    catch( const std::exception & ex )
    {
        std::cerr << "Error: " << ex.what() << std::endl;
        return 1;
    }

    return 0;
}
