#
# Obtain external projects.
#

gem 'Mxx_ru', '>= 1.6.8'

require 'mxx_ru/externals'

MxxRu::git_externals :cpprestsdk do |e|
  e.url 'https://github.com/Microsoft/cpprestsdk.git'
  e.commit 'a24b81a58bd34e3881fa0a1a37cd366c67b84d9a' # Nov 5, 2017

  e.map_dir 'Release/include' => 'dev/cpprestsdk'
  e.map_dir 'Release/src' => 'dev/cpprestsdk'
  e.map_dir 'Release/cmake' => 'dev/cpprestsdk'
end

MxxRu::git_externals :restbed do |e|
  e.url 'https://github.com/Corvusoft/restbed.git'
  e.recursive
  e.tag '4.6'

  e.map_dir 'source' => 'dev/restbed'
  e.map_dir 'dependency' => 'dev/restbed'
  e.map_dir 'cmake' => 'dev/restbed'
end

MxxRu::git_externals :beast do |e|
  e.url 'https://github.com/boostorg/beast'
  e.commit '885b9dfe0b6bfc7be6a9158d60f0760aa43e748a' #v123

  # Needs boost 1.66
  # e.commit '8414dbf73b50d4b67bd933f2fe20863dd73c3de5' #v148

  e.map_dir 'include' => 'dev/beast'
end

MxxRu::git_externals :pistache do |e|
  e.url 'https://github.com/oktal/pistache.git'
  e.commit 'b66415aaa0dc443b7874acbbb488058b34c2dc01' # Jul 30, 2017

  e.map_dir 'include' => 'dev/pistache'
  e.map_dir 'src' => 'dev/pistache'
end

MxxRu::arch_externals :poco do |e|
  # e.url 'https://pocoproject.org/releases/poco-1.7.9/poco-1.7.9p2.tar.gz' # Nov 7, 2017
  e.url 'https://pocoproject.org/releases/poco-1.8.0.1/poco-1.8.0.1-all.tar.bz2' # Nov 11, 2017
  e.map_dir 'Foundation' => 'dev/poco'
  e.map_dir 'Util' => 'dev/poco'
  e.map_dir 'Net' => 'dev/poco'
  e.map_dir 'cmake' => 'dev/poco'
  e.map_file 'libversion' => 'dev/poco/*'
  e.map_file 'VERSION' => 'dev/poco/*'
end

MxxRu::git_externals :crow do |e|
  e.url 'https://github.com/ipkn/crow.git'
  e.commit '7f3f72441c242836d00ab2109a83baef89c08aaa' # Oct 21, 2017

  e.map_dir 'include' => 'dev/crow'
  e.map_dir 'cmake' => 'dev/crow'
end

MxxRu::git_externals :asio_pure_asio_dep do |e|
  e.url 'https://github.com/chriskohlhoff/asio.git'
  e.commit '9229964dc1853b375077338cb398027a6dbbb148' # Dec 10 2017

  e.map_dir 'asio/include' => 'dev/pure_asio/asio'
end

MxxRu::arch_externals :args do |e|
  e.url 'https://github.com/Taywee/args/archive/6.0.4.tar.gz'

  e.map_file 'args.hxx' => 'dev/common_args/args/*'
end

MxxRu::arch_externals :restinio do |e|
  e.url 'https://bitbucket.org/sobjectizerteam/restinio-0.4/downloads/restinio-0.4.0-full.tar.bz2'

  e.map_dir 'dev/nodejs' => 'dev/restinio'
  e.map_dir 'dev/cmake' => 'dev/restinio/cmake'
  e.map_dir 'dev/restinio' => 'dev/restinio' # RESTinio itself.
  e.map_dir 'dev/benches' => 'dev/restinio' # Benchmark.
  e.map_dir 'dev/args' => 'dev/restinio'
  e.map_dir 'dev/asio' => 'dev/restinio'
  e.map_dir 'dev/asio_mxxru' => 'dev/restinio'
  e.map_dir 'dev/fmt' => 'dev/restinio'
  e.map_dir 'dev/fmt_mxxru' => 'dev/restinio'
end


